
clock_Read_Time:

;clock.mbas,26 :: 		sub procedure Read_Time()
;clock.mbas,27 :: 		Soft_I2C_Start()              ' Issue start signal
	CALL       _Soft_I2C_Start+0
;clock.mbas,28 :: 		Soft_I2C_Write(0xA0)          ' Address PCF8583, see PCF8583 datasheet
	MOVLW      160
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;clock.mbas,29 :: 		Soft_I2C_Write(2)             ' Start from address 2
	MOVLW      2
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;clock.mbas,30 :: 		Soft_I2C_Start()              ' Issue repeated start signal
	CALL       _Soft_I2C_Start+0
;clock.mbas,31 :: 		Soft_I2C_Write(0xA1)          ' Address PCF8583 for reading R/W=1
	MOVLW      161
	MOVWF      FARG_Soft_I2C_Write_data_+0
	CALL       _Soft_I2C_Write+0
;clock.mbas,32 :: 		seconds = Soft_I2C_Read(1)    ' Read seconds byte
	MOVLW      1
	MOVWF      FARG_Soft_I2C_Read_ack+0
	CLRF       FARG_Soft_I2C_Read_ack+1
	CALL       _Soft_I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      _seconds+0
;clock.mbas,33 :: 		minutes = Soft_I2C_Read(1)    ' Read minutes byte
	MOVLW      1
	MOVWF      FARG_Soft_I2C_Read_ack+0
	CLRF       FARG_Soft_I2C_Read_ack+1
	CALL       _Soft_I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      _minutes+0
;clock.mbas,34 :: 		hours = Soft_I2C_Read(1)      ' Read hours byte
	MOVLW      1
	MOVWF      FARG_Soft_I2C_Read_ack+0
	CLRF       FARG_Soft_I2C_Read_ack+1
	CALL       _Soft_I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      _hours+0
;clock.mbas,35 :: 		_day = Soft_I2C_Read(1)       ' Read year/day byte
	MOVLW      1
	MOVWF      FARG_Soft_I2C_Read_ack+0
	CLRF       FARG_Soft_I2C_Read_ack+1
	CALL       _Soft_I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      __day+0
;clock.mbas,36 :: 		_month = Soft_I2C_Read(0)     ' Read weekday/month byte}
	CLRF       FARG_Soft_I2C_Read_ack+0
	CLRF       FARG_Soft_I2C_Read_ack+1
	CALL       _Soft_I2C_Read+0
	MOVF       R0+0, 0
	MOVWF      __month+0
;clock.mbas,37 :: 		Soft_I2C_Stop()               ' Issue stop signal}
	CALL       _Soft_I2C_Stop+0
	RETURN
; end of clock_Read_Time

clock_Transform_Time:

;clock.mbas,39 :: 		sub procedure Transform_Time()
;clock.mbas,40 :: 		seconds  =  ((seconds and 0xF0) >> 4)*10 + (seconds and 0x0F)  ' Transform seconds
	MOVLW      240
	ANDWF      _seconds+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVLW      10
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      15
	ANDWF      _seconds+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ADDWF      R0+0, 0
	MOVWF      _seconds+0
;clock.mbas,41 :: 		minutes  =  ((minutes and 0xF0) >> 4)*10 + (minutes and 0x0F)  ' Transform months
	MOVLW      240
	ANDWF      _minutes+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVLW      10
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      15
	ANDWF      _minutes+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ADDWF      R0+0, 0
	MOVWF      _minutes+0
;clock.mbas,42 :: 		hours    =  ((hours and 0xF0)  >> 4)*10  + (hours and 0x0F)    ' Transform hours
	MOVLW      240
	ANDWF      _hours+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVLW      10
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      15
	ANDWF      _hours+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ADDWF      R0+0, 0
	MOVWF      _hours+0
;clock.mbas,43 :: 		year     =   ((_day and 0xC0) >> 6)+8                              ' Transform year
	MOVLW      192
	ANDWF      __day+0, 0
	MOVWF      _year+0
	MOVLW      6
	MOVWF      R0+0
	MOVF       R0+0, 0
L_clock_Transform_Time11:
	BTFSC      STATUS+0, 2
	GOTO       L_clock_Transform_Time12
	RRF        _year+0, 1
	BCF        _year+0, 7
	ADDLW      255
	GOTO       L_clock_Transform_Time11
L_clock_Transform_Time12:
	MOVLW      8
	ADDWF      _year+0, 1
;clock.mbas,44 :: 		_day      =  ((_day and 0x30) >> 4)*10    + (_day and 0x0F)    ' Transform day
	MOVLW      48
	ANDWF      __day+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVLW      10
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      15
	ANDWF      __day+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ADDWF      R0+0, 0
	MOVWF      __day+0
;clock.mbas,45 :: 		_month    =  ((_month and 0x10)  >> 4)*10 + (_month and 0x0F)  ' Transform month
	MOVLW      16
	ANDWF      __month+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	MOVWF      R0+0
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	RRF        R0+0, 1
	BCF        R0+0, 7
	MOVLW      10
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      15
	ANDWF      __month+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ADDWF      R0+0, 0
	MOVWF      __month+0
	RETURN
; end of clock_Transform_Time

clock_digit_conv:

;clock.mbas,48 :: 		sub procedure digit_conv()
;clock.mbas,49 :: 		if T[1]=" " then
	MOVF       _T+1, 0
	XORLW      32
	BTFSS      STATUS+0, 2
	GOTO       L_clock_digit_conv4
;clock.mbas,50 :: 		T[1]="0"
	MOVLW      48
	MOVWF      _T+1
L_clock_digit_conv4:
;clock.mbas,52 :: 		T2=t[1]+t[2]
	MOVLW      _T2+0
	MOVWF      FSR
	MOVF       _T+1, 0
	MOVWF      INDF+0
	INCF       FSR, 1
	MOVF       _T+2, 0
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
	RETURN
; end of clock_digit_conv

clock_Display_Time:

;clock.mbas,55 :: 		sub procedure Display_Time()
;clock.mbas,56 :: 		ByteToStr(_day, t)
	MOVF       __day+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _T+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;clock.mbas,57 :: 		digit_conv
	CALL       clock_digit_conv+0
;clock.mbas,58 :: 		txt=T2+"/"
	MOVLW      _txt+0
	MOVWF      FSR
	MOVLW      _T2+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      47
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
	INCF       FSR, 1
;clock.mbas,59 :: 		ByteToStr(_month, t)
	MOVF       __month+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _T+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;clock.mbas,60 :: 		digit_conv
	CALL       clock_digit_conv+0
;clock.mbas,61 :: 		txt=txt+T2+"/"
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      FSR
	MOVLW      _txt+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      _T2+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      47
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
	INCF       FSR, 1
	MOVLW      _txt+0
	MOVWF      FSR
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
;clock.mbas,62 :: 		ByteToStr(year, t)
	MOVF       _year+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _T+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;clock.mbas,63 :: 		digit_conv
	CALL       clock_digit_conv+0
;clock.mbas,64 :: 		txt=txt+T2+"    "
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      FSR
	MOVLW      _txt+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      _T2+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      32
	MOVWF      INDF+0
	INCF       FSR, 1
	MOVLW      32
	MOVWF      INDF+0
	INCF       FSR, 1
	MOVLW      32
	MOVWF      INDF+0
	INCF       FSR, 1
	MOVLW      32
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
	INCF       FSR, 1
	MOVLW      _txt+0
	MOVWF      FSR
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
;clock.mbas,65 :: 		ByteToStr(hours, t)
	MOVF       _hours+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _T+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;clock.mbas,66 :: 		digit_conv
	CALL       clock_digit_conv+0
;clock.mbas,67 :: 		txt=txt+T2+":"
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      FSR
	MOVLW      _txt+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      _T2+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      58
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
	INCF       FSR, 1
	MOVLW      _txt+0
	MOVWF      FSR
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
;clock.mbas,68 :: 		ByteToStr(minutes, t)
	MOVF       _minutes+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _T+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;clock.mbas,69 :: 		digit_conv
	CALL       clock_digit_conv+0
;clock.mbas,70 :: 		txt=txt+T2+":"
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      FSR
	MOVLW      _txt+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      _T2+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      58
	MOVWF      INDF+0
	INCF       FSR, 1
	CLRF       INDF+0
	INCF       FSR, 1
	MOVLW      _txt+0
	MOVWF      FSR
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
;clock.mbas,71 :: 		ByteToStr(seconds, t)
	MOVF       _seconds+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _T+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;clock.mbas,72 :: 		digit_conv
	CALL       clock_digit_conv+0
;clock.mbas,73 :: 		txt=txt+T2
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      FSR
	MOVLW      _txt+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	MOVLW      _T2+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
	MOVLW      _txt+0
	MOVWF      FSR
	MOVLW      FLOC_clock_Display_Time+0
	MOVWF      R1+0
	CALL       ___CS2S+0
	CLRF       INDF+0
;clock.mbas,74 :: 		lcd_out(1,1,txt)
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;clock.mbas,76 :: 		byteToStr(counter, t)
	MOVF       _counter+0, 0
	MOVWF      FARG_ByteToStr_input+0
	MOVLW      _T+0
	MOVWF      FARG_ByteToStr_output+0
	CALL       _ByteToStr+0
;clock.mbas,77 :: 		lcd_out(2,1,t)
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _T+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
	RETURN
; end of clock_Display_Time

clock_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;clock.mbas,80 :: 		sub procedure interrupt()
;clock.mbas,81 :: 		portb=not portb
	COMF       PORTB+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      PORTB+0
;clock.mbas,82 :: 		counter=counter+1
	INCF       _counter+0, 1
;clock.mbas,83 :: 		PIR1.TMR1IF = 0
	BCF        PIR1+0, 0
L_clock_interrupt13:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of clock_interrupt

_main:

;clock.mbas,86 :: 		main:
;clock.mbas,87 :: 		T1CON=53
	MOVLW      53
	MOVWF      T1CON+0
;clock.mbas,88 :: 		INTCON=192
	MOVLW      192
	MOVWF      INTCON+0
;clock.mbas,89 :: 		PIE1=1
	MOVLW      1
	MOVWF      PIE1+0
;clock.mbas,90 :: 		trisb=0
	CLRF       TRISB+0
;clock.mbas,91 :: 		portb=0
	CLRF       PORTB+0
;clock.mbas,92 :: 		Lcd_Init()
	CALL       _Lcd_Init+0
;clock.mbas,93 :: 		Soft_I2C_Init()
	CALL       _Soft_I2C_Init+0
;clock.mbas,94 :: 		Lcd_Cmd(_LCD_CURSOR_OFF)
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;clock.mbas,95 :: 		loop:
L__main_loop:
;clock.mbas,96 :: 		Read_Time
	CALL       clock_Read_Time+0
;clock.mbas,97 :: 		Transform_Time
	CALL       clock_Transform_Time+0
;clock.mbas,98 :: 		Display_Time
	CALL       clock_Display_Time+0
;clock.mbas,99 :: 		delay_ms (100)
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__main10:
	DECFSZ     R13+0, 1
	GOTO       L__main10
	DECFSZ     R12+0, 1
	GOTO       L__main10
	DECFSZ     R11+0, 1
	GOTO       L__main10
	NOP
;clock.mbas,100 :: 		goto loop
	GOTO       L__main_loop
	GOTO       $+0
; end of _main
